function z=convolve(a,b)
%convolve - brute force convolution of two vectors
%
diagnostic=1;

[r,c] = size(a);
if r>1 & c>1, error('This route works with vectors only'), end;
va = a;
if r>1 va = va', end;	% force input to be a row vector

[r,c] = size(b);
if r>1 & c>1, error('This route works with vectors only'), end;
vb = b;
if r>1 vb = vb', end;	% force input to be a row vector
	
if length(va) > length(vb)
	A = a;				% A is the longer of the two vectors
	B = fliplr(b);		% B is short vector, flipped about origin
else
	A = b;
	B = fliplr(a);
end

sA = length(A);
sB = length(B);
Apad = zeros(1,sB-1);
newA = [Apad A Apad];
nA = length(newA);
t = 1:nA;

Bpad = zeros(1,nA-sB);
newB = [B Bpad];

z=zeros(1,nA);			% do the shift & inner product
for i=1:nA-sB+1
	z(i) = newA*newB';
	newB = rotR(newB,1); % break here to see the action
    if diagnostic
        figure(1)
        plot(t,newA, t,newB)
        pause(0.2)
    end
end
z=z(1:nA-sB+1);
